package gov.nih.nci.evs.domain;


import java.io.Serializable;
import gov.nih.nci.evs.annotation.LazyLoad;
import java.lang.annotation.*;
	/**
	* Atom is an occurrence of a term in a source.	**/
public class Atom  implements Serializable
{
	/**
	* An attribute to allow serialization of the domain objects
	*/
	private static final long serialVersionUID = 1234567890L;

	
	
		/**
	* The code is a unique identifer within a source associated to the atom	**/
	private String code;
	/**
	* Retreives the value of code attribue
	* @return code
	**/

	  public String getCode(){
		return code;
	}

	/**
	* Sets the value of code attribue
	**/

	public void setCode(String code){
		this.code = code;
	}
	
	
		/**
	* The lui holds the Lexical unique identifier for the atom	**/
	private String lui;
	/**
	* Retreives the value of lui attribue
	* @return lui
	**/

	  public String getLui(){
		return lui;
	}

	/**
	* Sets the value of lui attribue
	**/

	public void setLui(String lui){
		this.lui = lui;
	}
	
	
		/**
	* The name attribute stores the name of the term 	**/
	private String name;
	/**
	* Retreives the value of name attribue
	* @return name
	**/

	  public String getName(){
		return name;
	}

	/**
	* Sets the value of name attribue
	**/

	public void setName(String name){
		this.name = name;
	}
	
	
		/**
	* The origin attribute holds the origin of the atom	**/
	private String origin;
	/**
	* Retreives the value of origin attribue
	* @return origin
	**/

	  public String getOrigin(){
		return origin;
	}

	/**
	* Sets the value of origin attribue
	**/

	public void setOrigin(String origin){
		this.origin = origin;
	}
	
	/**
	* An associated gov.nih.nci.evs.domain.Source object
	**/
			
	private Source source;
	/**
	* Retreives the value of source attribue
	* @return source
	**/
	
	  public Source getSource(){
		return source;
	}
	/**
	* Sets the value of source attribue
	**/

	public void setSource(Source source){
		this.source = source;
	}
			
}