package gov.nih.nci.evs.domain;

import java.util.Collection;
import java.io.Serializable;
import gov.nih.nci.evs.annotation.LazyLoad;
import java.lang.annotation.*;
	/**
	* AttributeSetDescriptor class specifies the set of concept attributes that should be retrieved by a given operation. 	**/
public class AttributeSetDescriptor  implements Serializable
{
	/**
	* An attribute to allow serialization of the domain objects
	*/
	private static final long serialVersionUID = 1234567890L;

	
	
		/**
	* Specifies the name for an AttributeSetDescriptor instance	**/
	private String name;
	/**
	* Retreives the value of name attribue
	* @return name
	**/

	  public String getName(){
		return name;
	}

	/**
	* Sets the value of name attribue
	**/

	public void setName(String name){
		this.name = name;
	}
	
	
		/**
	* A special constant that specifies all concept attributes to be fetched.	**/
	private Integer WITH_ALL_ATTRIBUTES;
	/**
	* Retreives the value of WITH_ALL_ATTRIBUTES attribue
	* @return WITH_ALL_ATTRIBUTES
	**/

	  public Integer getWITH_ALL_ATTRIBUTES(){
		return WITH_ALL_ATTRIBUTES;
	}

	/**
	* Sets the value of WITH_ALL_ATTRIBUTES attribue
	**/

	public void setWITH_ALL_ATTRIBUTES(Integer WITH_ALL_ATTRIBUTES){
		this.WITH_ALL_ATTRIBUTES = WITH_ALL_ATTRIBUTES;
	}
	
	
		/**
	* A special constant that specifies all properties of a concept to be fetched.	**/
	private Integer WITH_ALL_PROPERTIES;
	/**
	* Retreives the value of WITH_ALL_PROPERTIES attribue
	* @return WITH_ALL_PROPERTIES
	**/

	  public Integer getWITH_ALL_PROPERTIES(){
		return WITH_ALL_PROPERTIES;
	}

	/**
	* Sets the value of WITH_ALL_PROPERTIES attribue
	**/

	public void setWITH_ALL_PROPERTIES(Integer WITH_ALL_PROPERTIES){
		this.WITH_ALL_PROPERTIES = WITH_ALL_PROPERTIES;
	}
	
	
		/**
	* A special constant that specifies all roles of a concept to be fetched.	**/
	private Integer WITH_ALL_ROLES;
	/**
	* Retreives the value of WITH_ALL_ROLES attribue
	* @return WITH_ALL_ROLES
	**/

	  public Integer getWITH_ALL_ROLES(){
		return WITH_ALL_ROLES;
	}

	/**
	* Sets the value of WITH_ALL_ROLES attribue
	**/

	public void setWITH_ALL_ROLES(Integer WITH_ALL_ROLES){
		this.WITH_ALL_ROLES = WITH_ALL_ROLES;
	}
	
	
		/**
	* A special constant that specifies no concept attributes to be fetched.	**/
	private Integer WITH_NO_ATTRIBUTES;
	/**
	* Retreives the value of WITH_NO_ATTRIBUTES attribue
	* @return WITH_NO_ATTRIBUTES
	**/

	  public Integer getWITH_NO_ATTRIBUTES(){
		return WITH_NO_ATTRIBUTES;
	}

	/**
	* Sets the value of WITH_NO_ATTRIBUTES attribue
	**/

	public void setWITH_NO_ATTRIBUTES(Integer WITH_NO_ATTRIBUTES){
		this.WITH_NO_ATTRIBUTES = WITH_NO_ATTRIBUTES;
	}
	
	/**
	* An associated gov.nih.nci.evs.domain.Role object's collection 
	**/
	
		
	private java.util.Vector<Role> roleCollection;
	/**
	* Retreives the value of roleCollection attribue
	* @return roleCollection
	**/

	
	  public java.util.Vector<Role> getRoleCollection(){
		return roleCollection;
	}

	/**
	* Sets the value of roleCollection attribue
	**/

	public void setRoleCollection(java.util.Vector<Role> roleCollection){
		this.roleCollection = roleCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Property object's collection 
	**/
	
		
	private java.util.Vector<Property> propertyCollection;
	/**
	* Retreives the value of propertyCollection attribue
	* @return propertyCollection
	**/

	
	  public java.util.Vector<Property> getPropertyCollection(){
		return propertyCollection;
	}

	/**
	* Sets the value of propertyCollection attribue
	**/

	public void setPropertyCollection(java.util.Vector<Property> propertyCollection){
		this.propertyCollection = propertyCollection;
	}
		
}