package gov.nih.nci.evs.domain;

import java.util.Collection;
import java.io.Serializable;
import gov.nih.nci.evs.annotation.LazyLoad;
import java.lang.annotation.*;
	/**
	* The DescLogicConcept class represents the fundamental vocabulary entity in the NCI Thesaurus. 	**/
public class DescLogicConcept  implements Serializable
{
	/**
	* An attribute to allow serialization of the domain objects
	*/
	private static final long serialVersionUID = 1234567890L;

	
	
		/**
	* This is an unique code associated with a concept within the specified vocabulary. 	**/
	private String code;
	/**
	* Retreives the value of code attribue
	* @return code
	**/

	  public String getCode(){
		return code;
	}

	/**
	* Sets the value of code attribue
	**/

	public void setCode(String code){
		this.code = code;
	}
	
	
		/**
	* Sets this value to 'true' if a concept has children	**/
	private Boolean hasChildren;
	/**
	* Retreives the value of hasChildren attribue
	* @return hasChildren
	**/

	@LazyLoad public Boolean getHasChildren(){
		return hasChildren;
	}

	/**
	* Sets the value of hasChildren attribue
	**/

	public void setHasChildren(Boolean hasChildren){
		this.hasChildren = hasChildren;
	}
	
	
		/**
	* This value is set to 'true' if a concept has a parent	**/
	private Boolean hasParents;
	/**
	* Retreives the value of hasParents attribue
	* @return hasParents
	**/

	@LazyLoad public Boolean getHasParents(){
		return hasParents;
	}

	/**
	* Sets the value of hasParents attribue
	**/

	public void setHasParents(Boolean hasParents){
		this.hasParents = hasParents;
	}
	
	
		/**
	* Sets this value to 'true'  if a concept is retired. 	**/
	private Boolean isRetired;
	/**
	* Retreives the value of isRetired attribue
	* @return isRetired
	**/

	@LazyLoad public Boolean getIsRetired(){
		return isRetired;
	}

	/**
	* Sets the value of isRetired attribue
	**/

	public void setIsRetired(Boolean isRetired){
		this.isRetired = isRetired;
	}
	
	
		/**
	* Specifies the name of the concept. 	**/
	private String name;
	/**
	* Retreives the value of name attribue
	* @return name
	**/

	  public String getName(){
		return name;
	}

	/**
	* Sets the value of name attribue
	**/

	public void setName(String name){
		this.name = name;
	}
	
	
		/**
	* The namespaceId is used to identify a set of concepts within a terminology such as the NCI Thesaurus.	**/
	private Integer namespaceId;
	/**
	* Retreives the value of namespaceId attribue
	* @return namespaceId
	**/

	  public Integer getNamespaceId(){
		return namespaceId;
	}

	/**
	* Sets the value of namespaceId attribue
	**/

	public void setNamespaceId(Integer namespaceId){
		this.namespaceId = namespaceId;
	}
	
	
		/**
	* 	**/
	private java.util.Vector semanticTypeVector;
	/**
	* Retreives the value of semanticTypeVector attribue
	* @return semanticTypeVector
	**/

	@LazyLoad public java.util.Vector getSemanticTypeVector(){
		return semanticTypeVector;
	}

	/**
	* Sets the value of semanticTypeVector attribue
	**/

	public void setSemanticTypeVector(java.util.Vector semanticTypeVector){
		this.semanticTypeVector = semanticTypeVector;
	}
	
	/**
	* An associated gov.nih.nci.evs.domain.Role object's collection 
	**/
	
		
	private java.util.Vector<Role> inverseRoleCollection;
	/**
	* Retreives the value of inverseRoleCollection attribue
	* @return inverseRoleCollection
	**/

	
	@LazyLoad  public java.util.Vector<Role> getInverseRoleCollection(){
		return inverseRoleCollection;
	}

	/**
	* Sets the value of inverseRoleCollection attribue
	**/

	public void setInverseRoleCollection(java.util.Vector<Role> inverseRoleCollection){
		this.inverseRoleCollection = inverseRoleCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Association object's collection 
	**/
	
		
	private java.util.Vector<Association> associationCollection;
	/**
	* Retreives the value of associationCollection attribue
	* @return associationCollection
	**/

	
	@LazyLoad  public java.util.Vector<Association> getAssociationCollection(){
		return associationCollection;
	}

	/**
	* Sets the value of associationCollection attribue
	**/

	public void setAssociationCollection(java.util.Vector<Association> associationCollection){
		this.associationCollection = associationCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Role object's collection 
	**/
	
		
	private java.util.Vector<Role> roleCollection;
	/**
	* Retreives the value of roleCollection attribue
	* @return roleCollection
	**/

	
	@LazyLoad  public java.util.Vector<Role> getRoleCollection(){
		return roleCollection;
	}

	/**
	* Sets the value of roleCollection attribue
	**/

	public void setRoleCollection(java.util.Vector<Role> roleCollection){
		this.roleCollection = roleCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Association object's collection 
	**/
	
		
	private java.util.Vector<Association> inverseAssociationCollection;
	/**
	* Retreives the value of inverseAssociationCollection attribue
	* @return inverseAssociationCollection
	**/

	
	@LazyLoad  public java.util.Vector<Association> getInverseAssociationCollection(){
		return inverseAssociationCollection;
	}

	/**
	* Sets the value of inverseAssociationCollection attribue
	**/

	public void setInverseAssociationCollection(java.util.Vector<Association> inverseAssociationCollection){
		this.inverseAssociationCollection = inverseAssociationCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Property object's collection 
	**/
	
		
	private java.util.Vector<Property> propertyCollection;
	/**
	* Retreives the value of propertyCollection attribue
	* @return propertyCollection
	**/

	
	@LazyLoad  public java.util.Vector<Property> getPropertyCollection(){
		return propertyCollection;
	}

	/**
	* Sets the value of propertyCollection attribue
	**/

	public void setPropertyCollection(java.util.Vector<Property> propertyCollection){
		this.propertyCollection = propertyCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.TreeNode object
	**/
			
	private TreeNode treeNode;
	/**
	* Retreives the value of treeNode attribue
	* @return treeNode
	**/
	
	  public TreeNode getTreeNode(){
		return treeNode;
	}
	/**
	* Sets the value of treeNode attribue
	**/

	public void setTreeNode(TreeNode treeNode){
		this.treeNode = treeNode;
	}
			
	/**
	* An associated gov.nih.nci.evs.domain.HistoryRecord object
	**/
			
	private HistoryRecord historyRecord;
	/**
	* Retreives the value of historyRecord attribue
	* @return historyRecord
	**/
	
	@LazyLoad  public HistoryRecord getHistoryRecord(){
		return historyRecord;
	}
	/**
	* Sets the value of historyRecord attribue
	**/

	public void setHistoryRecord(HistoryRecord historyRecord){
		this.historyRecord = historyRecord;
	}
			
	/**
	* An associated gov.nih.nci.evs.domain.Vocabulary object
	**/
			
	private Vocabulary vocabulary;
	/**
	* Retreives the value of vocabulary attribue
	* @return vocabulary
	**/
	
	  public Vocabulary getVocabulary(){
		return vocabulary;
	}
	/**
	* Sets the value of vocabulary attribue
	**/

	public void setVocabulary(Vocabulary vocabulary){
		this.vocabulary = vocabulary;
	}
			
	/**
	* An associated gov.nih.nci.evs.domain.EdgeProperties object
	**/
			
	private EdgeProperties edgeProperties;
	/**
	* Retreives the value of edgeProperties attribue
	* @return edgeProperties
	**/
	
	  public EdgeProperties getEdgeProperties(){
		return edgeProperties;
	}
	/**
	* Sets the value of edgeProperties attribue
	**/

	public void setEdgeProperties(EdgeProperties edgeProperties){
		this.edgeProperties = edgeProperties;
	}
			
}