package gov.nih.nci.evs.domain;


import java.io.Serializable;
import gov.nih.nci.evs.annotation.LazyLoad;
import java.lang.annotation.*;
	/**
	* The EdgeProperties class specifies the relationship between a concept and its immediate parent when a  TREE is generated using the getTree method. 	**/
public class EdgeProperties  implements Serializable
{
	/**
	* An attribute to allow serialization of the domain objects
	*/
	private static final long serialVersionUID = 1234567890L;

	
	
		/**
	* Specifes the isa value for this concept. If a relationship type between this concept and the parent is a "isa" this value is set to true.	**/
	private Boolean isA;
	/**
	* Retreives the value of isA attribue
	* @return isA
	**/

	  public Boolean getIsA(){
		return isA;
	}

	/**
	* Sets the value of isA attribue
	**/

	public void setIsA(Boolean isA){
		this.isA = isA;
	}
	
	
		/**
	* Specifes the link information used  to generate the concept tree	**/
	private java.util.HashSet links;
	/**
	* Retreives the value of links attribue
	* @return links
	**/

	  public java.util.HashSet getLinks(){
		return links;
	}

	/**
	* Sets the value of links attribue
	**/

	public void setLinks(java.util.HashSet links){
		this.links = links;
	}
	
	
		/**
	* Specifes the name for this instance	**/
	private String name;
	/**
	* Retreives the value of name attribue
	* @return name
	**/

	  public String getName(){
		return name;
	}

	/**
	* Sets the value of name attribue
	**/

	public void setName(String name){
		this.name = name;
	}
	
	
		/**
	* The direction specified when the concept tree was generated. 	**/
	private Boolean traverseDown;
	/**
	* Retreives the value of traverseDown attribue
	* @return traverseDown
	**/

	  public Boolean getTraverseDown(){
		return traverseDown;
	}

	/**
	* Sets the value of traverseDown attribue
	**/

	public void setTraverseDown(Boolean traverseDown){
		this.traverseDown = traverseDown;
	}
	
}