package gov.nih.nci.evs.domain;

import java.util.Collection;
import java.io.Serializable;
import gov.nih.nci.evs.annotation.LazyLoad;
import java.lang.annotation.*;
	/**
	* MetaThesaurusConcept is the fundamental vocabulary entity in the NCI MetaThesaurus.	**/
public class MetaThesaurusConcept  implements Serializable
{
	/**
	* An attribute to allow serialization of the domain objects
	*/
	private static final long serialVersionUID = 1234567890L;

	
	
		/**
	* CUI is the Concept Unique Identifier within the MetaThesaurus.	**/
	private String cui;
	/**
	* Retreives the value of cui attribue
	* @return cui
	**/

	  public String getCui(){
		return cui;
	}

	/**
	* Sets the value of cui attribue
	**/

	public void setCui(String cui){
		this.cui = cui;
	}
	
	
		/**
	* Specifies the concept name	**/
	private String name;
	/**
	* Retreives the value of name attribue
	* @return name
	**/

	  public String getName(){
		return name;
	}

	/**
	* Sets the value of name attribue
	**/

	public void setName(String name){
		this.name = name;
	}
	
	
		/**
	* Specifies sysnonyms for the concept	**/
	private java.util.ArrayList synonymCollection;
	/**
	* Retreives the value of synonymCollection attribue
	* @return synonymCollection
	**/

	@LazyLoad public java.util.ArrayList getSynonymCollection(){
		return synonymCollection;
	}

	/**
	* Sets the value of synonymCollection attribue
	**/

	public void setSynonymCollection(java.util.ArrayList synonymCollection){
		this.synonymCollection = synonymCollection;
	}
	
	/**
	* An associated gov.nih.nci.evs.domain.SemanticType object's collection 
	**/
	
		
	private java.util.ArrayList<SemanticType> semanticTypeCollection;
	/**
	* Retreives the value of semanticTypeCollection attribue
	* @return semanticTypeCollection
	**/

	
	@LazyLoad  public java.util.ArrayList<SemanticType> getSemanticTypeCollection(){
		return semanticTypeCollection;
	}

	/**
	* Sets the value of semanticTypeCollection attribue
	**/

	public void setSemanticTypeCollection(java.util.ArrayList<SemanticType> semanticTypeCollection){
		this.semanticTypeCollection = semanticTypeCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Source object's collection 
	**/
	
		
	private java.util.ArrayList<Source> sourceCollection;
	/**
	* Retreives the value of sourceCollection attribue
	* @return sourceCollection
	**/

	
	@LazyLoad  public java.util.ArrayList<Source> getSourceCollection(){
		return sourceCollection;
	}

	/**
	* Sets the value of sourceCollection attribue
	**/

	public void setSourceCollection(java.util.ArrayList<Source> sourceCollection){
		this.sourceCollection = sourceCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Definition object's collection 
	**/
	
		
	private java.util.ArrayList<Definition> definitionCollection;
	/**
	* Retreives the value of definitionCollection attribue
	* @return definitionCollection
	**/

	
	@LazyLoad  public java.util.ArrayList<Definition> getDefinitionCollection(){
		return definitionCollection;
	}

	/**
	* Sets the value of definitionCollection attribue
	**/

	public void setDefinitionCollection(java.util.ArrayList<Definition> definitionCollection){
		this.definitionCollection = definitionCollection;
	}
		
	/**
	* An associated gov.nih.nci.evs.domain.Atom object's collection 
	**/
	
		
	private java.util.ArrayList<Atom> atomCollection;
	/**
	* Retreives the value of atomCollection attribue
	* @return atomCollection
	**/

	
	@LazyLoad  public java.util.ArrayList<Atom> getAtomCollection(){
		return atomCollection;
	}

	/**
	* Sets the value of atomCollection attribue
	**/

	public void setAtomCollection(java.util.ArrayList<Atom> atomCollection){
		this.atomCollection = atomCollection;
	}
		
}