package gov.nih.nci.evs.domain;

import java.util.Collection;
import java.io.Serializable;
import gov.nih.nci.evs.annotation.LazyLoad;
import java.lang.annotation.*;
	/**
	* Property is an attribute of a concept. Examples of properties are "Synonym", "Preferred_Name", "Semantic_Type" etc.	**/
public class Property  implements Serializable
{
	/**
	* An attribute to allow serialization of the domain objects
	*/
	private static final long serialVersionUID = 1234567890L;

	
	
		/**
	* Specifies the name of this property	**/
	private String name;
	/**
	* Retreives the value of name attribue
	* @return name
	**/

	  public String getName(){
		return name;
	}

	/**
	* Sets the value of name attribue
	**/

	public void setName(String name){
		this.name = name;
	}
	
	
		/**
	* Specifies the value of this property	**/
	private String value;
	/**
	* Retreives the value of value attribue
	* @return value
	**/

	  public String getValue(){
		return value;
	}

	/**
	* Sets the value of value attribue
	**/

	public void setValue(String value){
		this.value = value;
	}
	
	/**
	* An associated gov.nih.nci.evs.domain.Qualifier object's collection 
	**/
	
		
	private java.util.Vector<Qualifier> qualifierCollection;
	/**
	* Retreives the value of qualifierCollection attribue
	* @return qualifierCollection
	**/

	
	  public java.util.Vector<Qualifier> getQualifierCollection(){
		return qualifierCollection;
	}

	/**
	* Sets the value of qualifierCollection attribue
	**/

	public void setQualifierCollection(java.util.Vector<Qualifier> qualifierCollection){
		this.qualifierCollection = qualifierCollection;
	}
		
}