package gov.nih.nci.lexbig.ext;

import gov.nih.nci.system.applicationservice.*;
import gov.nih.nci.system.client.*;

import java.sql.Timestamp;
import java.util.Collection;
import java.util.Iterator;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.naming.*;


import org.apache.log4j.Logger;
import java.io.File;
import java.util.List;

import java.util.Vector;

import java.util.Set;
import java.util.HashSet;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;

//import javax.annotation.Resource;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.text.SimpleDateFormat;
import java.io.BufferedWriter;
import java.io.FileWriter;

import org.LexGrid.LexBIG.DataModel.Core.AbsoluteCodingSchemeVersionReference;
import org.LexGrid.LexBIG.Exceptions.LBResourceUnavailableException;
import org.LexGrid.LexBIG.Impl.dataAccess.ResourceManager;
import org.LexGrid.LexBIG.LexBIGService.LexBIGServiceManager;
import org.LexGrid.LexBIG.LexBIGService.CodedNodeSet.PropertyType;

import java.io.RandomAccessFile;


import org.LexGrid.LexBIG.DataModel.Core.Association;

import org.LexGrid.util.sql.sqlReconnect.ConnectionHelper;


import org.LexGrid.LexBIG.DataModel.Collections.CodingSchemeRenderingList;
import org.LexGrid.LexBIG.DataModel.Core.CodingSchemeSummary;
import org.LexGrid.LexBIG.Impl.dataAccess.ResourceManager;
import org.LexGrid.LexBIG.Utility.Constructors;
import org.LexGrid.LexBIG.Utility.ObjectToString;
import org.LexGrid.codingSchemes.CodingScheme;
import org.LexGrid.codingSchemes.Mappings;

import java.util.Enumeration;
import org.LexGrid.LexBIG.DataModel.Collections.AssociatedConceptList;
import org.LexGrid.LexBIG.DataModel.Collections.LocalNameList;
import org.LexGrid.LexBIG.DataModel.Collections.AssociationList;
import org.LexGrid.LexBIG.DataModel.Collections.SortOptionList;
import org.LexGrid.LexBIG.DataModel.Collections.NameAndValueList;
import org.LexGrid.LexBIG.DataModel.Collections.ResolvedConceptReferenceList;
import org.LexGrid.LexBIG.Utility.Iterators.ResolvedConceptReferencesIterator;
import org.LexGrid.LexBIG.DataModel.Core.AssociatedConcept;
import org.LexGrid.LexBIG.DataModel.Core.Association;
import org.LexGrid.LexBIG.DataModel.Core.CodingSchemeSummary;
import org.LexGrid.LexBIG.DataModel.Core.CodingSchemeVersionOrTag;
import org.LexGrid.LexBIG.DataModel.Core.ResolvedConceptReference;
import org.LexGrid.LexBIG.DataModel.InterfaceElements.CodingSchemeRendering;
import org.LexGrid.LexBIG.Exceptions.LBException;
import org.LexGrid.LexBIG.Exceptions.LBInvocationException;
import org.LexGrid.LexBIG.Exceptions.LBParameterException;
import org.LexGrid.LexBIG.Impl.LexBIGServiceImpl;
import org.LexGrid.LexBIG.LexBIGService.CodedNodeSet;
import org.LexGrid.LexBIG.LexBIGService.CodedNodeSet.SearchDesignationOption;
import org.LexGrid.LexBIG.LexBIGService.LexBIGService;
import org.LexGrid.LexBIG.LexBIGService.LexBIGServiceMetadata;
import org.LexGrid.LexBIG.DataModel.Collections.MetadataPropertyList;
import org.LexGrid.LexBIG.DataModel.Core.MetadataProperty;

import org.LexGrid.LexBIG.Utility.ConvenienceMethods;
import org.LexGrid.concepts.CodedEntry;
import org.LexGrid.commonTypes.Property;
import org.LexGrid.concepts.Definition;
import org.LexGrid.concepts.Presentation;
import org.LexGrid.concepts.Comment;
import org.LexGrid.LexBIG.Utility.LBConstants.MatchAlgorithms;
import org.LexGrid.LexBIG.DataModel.Core.CodingSchemeVersionOrTag;
import org.LexGrid.LexBIG.LexBIGService.CodedNodeGraph;
import org.LexGrid.LexBIG.LexBIGService.CodedNodeSet;
import org.LexGrid.naming.SupportedAssociation;
import org.LexGrid.LexBIG.Impl.CodedNodeSetImpl;
import org.LexGrid.naming.SupportedProperty;
import org.LexGrid.LexBIG.Exceptions.LBResourceUnavailableException;
import org.LexGrid.LexBIG.DataModel.Core.NameAndValue;
import org.LexGrid.LexBIG.DataModel.Collections.NameAndValueList;

import org.LexGrid.LexBIG.DataModel.Collections.ConceptReferenceList;
import org.LexGrid.LexBIG.DataModel.Collections.ResolvedConceptReferenceList;

import org.LexGrid.LexBIG.DataModel.Collections.AbsoluteCodingSchemeVersionReferenceList;
import java.util.regex.Pattern;

import org.LexGrid.commonTypes.Source;

import org.LexGrid.LexBIG.DataModel.InterfaceElements.RenderingDetail;
import org.LexGrid.LexBIG.DataModel.Core.ConceptReference;

import java.util.*;
import gov.nih.nci.lexbig.ext.*;

//GF9215
import org.LexGrid.LexBIG.LexBIGService.CodedNodeSet.ActiveOption;

public class SearchUtil {

	public static final int SEARCH_STARTS_WITH = 1;
	public static final int SEARCH_ENDS_WITH = 2;
	public static final int SEARCH_CONTAINS = 3;
	public static final int SEARCH_EXACT_MATCH = 4;


	private static Logger log = Logger.getLogger("session.FileAndVersionSessionBeanImpl");

	private static Logger KLO_log = Logger.getLogger("KLO");

	static final List STOP_WORDS = Arrays.asList(new String[] {"a", "an", "of", "the"});


	private ResolvedConceptReferencesIterator searchResultIterator = null;

	private LexBIGService lbSvc;
	private String url;
	private String codingSchemeName;
	private String version;
	private CodingScheme codingScheme;
	private String tag = null;

	//DLBAdapter adapter = null;

	public SearchUtil(String codingSchemeName, String version, String url )
	{
		this.url = url;
		this.lbSvc = createLexBIGService(url);
		this.codingSchemeName= codingSchemeName;
		this.version = version;
		try {
			this.codingScheme = getCodingScheme(codingSchemeName, version);
	    } catch (Exception e) {
			e.printStackTrace();
		}
	}


	public SearchUtil(String codingSchemeName, String version, LexBIGService lbSvc )
	{
		this.url = url;
		this.lbSvc = lbSvc;
		this.codingSchemeName= codingSchemeName;
		this.version = version;
		try {
			this.codingScheme = getCodingScheme(codingSchemeName, version);
	    } catch (Exception e) {
			e.printStackTrace();
		}
	}


	public LexBIGService createLexBIGService(String url)
    {
		LexBIGService lbSvc = null;
		try {
			if (url == null)
			{
				return new LexBIGServiceImpl();
			}
			else if (url.compareTo("") == 0)
			{
				return new LexBIGServiceImpl();
			}

			try {
				return (EVSApplicationService)ApplicationServiceProvider.getApplicationServiceFromUrl(url);
			} catch (Exception e) {
				return null;
		    }
		} catch (Exception e) {
			e.printStackTrace();
            return null;
        }
	}

    public Vector getSupportedAssociations()
	{
		if (codingScheme == null) return null;
        Vector v = new Vector();
	    SupportedAssociation[] associations = codingScheme.getMappings().getSupportedAssociation();
		for (int i=0; i<associations.length; i++)
		{
		     SupportedAssociation asso = (SupportedAssociation) associations[i];
		     v.add(asso.getLocalId());
		}
        return v;
	}


	public CodingScheme getCodingScheme(String codingSchemeName, String version) throws Exception {
		try {
			CodingSchemeRenderingList csrl = lbSvc.getSupportedCodingSchemes();
			CodingSchemeRendering[] csrs = csrl.getCodingSchemeRendering();
			for (int i=0; i<csrs.length; i++)
			{
				CodingSchemeRendering csr = csrs[i];
				CodingSchemeSummary css = csr.getCodingSchemeSummary();
				String formalname = css.getFormalName();
				if (formalname.compareTo(codingSchemeName) == 0) {
					CodingSchemeVersionOrTag vt = new CodingSchemeVersionOrTag();
					vt.setVersion(version);
					CodingScheme scheme = lbSvc.resolveCodingScheme(formalname, vt);
					return scheme;
				}
				String localName = css.getLocalName();
				if (localName.compareTo(codingSchemeName) == 0) {
					CodingSchemeVersionOrTag vt = new CodingSchemeVersionOrTag();
					vt.setVersion(version);
					CodingScheme scheme = lbSvc.resolveCodingScheme(formalname, vt);
					return scheme;
				}
			}
		} catch (Exception e) {
			//e.printStackTrace();
			System.out.println("*** getCodingScheme exception.");
		}
		return null;
	}

	protected CodedNodeSet restrictToSource(CodedNodeSet cns, String source)
	{
		if (source == null || source.compareTo("*") == 0) return cns;
		Vector v = new Vector();
		v.add(source);
	    LocalNameList sourceList = vector2LocalNameList(v);
		CodedNodeSet.PropertyType[] types = new CodedNodeSet.PropertyType[] {CodedNodeSet.PropertyType.PRESENTATION};
		try {

			cns = cns.restrictToProperties(null, types, sourceList, null, null);

		} catch (Exception e) {
   			System.out.println("restrictToSource error. Source: " + source);
		    return null;
		}
		return cns;
	}


	public String[] getPropertyForCodingSchemeSearch(){
		int count = codingScheme.getMappings().getSupportedPropertyCount();
		ArrayList lst = new ArrayList();
		Mappings mappings = codingScheme.getMappings();
		SupportedProperty[] sp = codingScheme.getMappings().getSupportedProperty();
		for(int i=0;i<count ;i++){
			SupportedProperty prop = sp[i];
			if( prop!=null && prop.getLocalId()!=null && !prop.getLocalId().equalsIgnoreCase("textualPresentation")){
				lst.add(prop.getLocalId());
			}
		}
		String[] str = new String[lst.size()];
		for(int j=0;j<lst.size();j++){
			str[j] = lst.get(j).toString();
		}

		return str;
	}

	private String replacePeriod(String s){
		String temp = "";
		if(s.indexOf(".") < 0)
			return s;
		while(s.indexOf(".") >= 0){
			temp = temp + s.substring(0,s.indexOf(".")) + "\\.";
			s = s.substring(s.indexOf(".") +1);
		}
		temp += s;
		return temp;
	}

	public LocalNameList vector2LocalNameList(Vector v)
	{
		if (v == null) return null;
		LocalNameList list = new LocalNameList();
		for (int i=0; i<v.size(); i++)
		{
			String vEntry = (String) v.elementAt(i);
			list.addEntry(vEntry);
		}
        return list;
	}


	private NameAndValueList createNameAndValueList(String[] names, String[] values)
	{
		NameAndValueList nvList = new NameAndValueList();
		for (int i=0; i<names.length; i++)
		{
			NameAndValue nv = new NameAndValue();
			nv.setName(names[i]);
			if (values != null)
			{
				nv.setContent(values[i]);
			}
			nvList.addNameAndValue(nv);
		}
		return nvList;
	}


    private ConceptReferenceList resolvedConceptReferenceListToConceptReferenceList(ResolvedConceptReferenceList rcrl)
    {
		ResolvedConceptReference[] rcr_array =	rcrl.getResolvedConceptReference();
		ConceptReferenceList crl = new ConceptReferenceList();

		for (int i=0; i<rcr_array.length; i++)
		{
			ResolvedConceptReference rcr = rcr_array[i];
			CodedEntry ce =rcr.getReferencedEntry();
			crl.addConceptReference(rcr);
		}
		return crl;
    }


	public ResolvedConceptReferencesIterator searchNodesForDefinition(List names, int count, boolean soundsLike, boolean searchInactive){
		ResolvedConceptReferencesIterator matchIterator = null;
		try{
			String scheme = codingScheme.getRegisteredName();
			CodedNodeSet nodes = lbSvc.getCodingSchemeConcepts(scheme, null);
			String name = null;
			Iterator namesIte = names.iterator();
			String matchAlgorithm = "RegExp";
			if(soundsLike)
				matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

			while(namesIte.hasNext()){
				name = (String)namesIte.next();
				name = name.toLowerCase();
				name = replacePeriod(name);
				if(name.indexOf(" ") > 0){
					name = "\"" + name + "\"";
					matchAlgorithm = MatchAlgorithms.LuceneQuery.name();
				}
				else{

					if(!soundsLike){
						name = ".*" + name + ".*";
						matchAlgorithm = "RegExp";

					}
				}

				if(soundsLike)
					matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

/*
 CodedNodeSet 	restrictToMatchingProperties(LocalNameList propertyNames,
                                             CodedNodeSet.PropertyType[] propertyTypes,
                                             java.lang.String matchText,
                                             java.lang.String matchAlgorithm,
                                             java.lang.String language)
 */
				nodes = nodes.restrictToMatchingProperties(
					null,
					new PropertyType[] {PropertyType.DEFINITION},
					name,
					soundsLike?MatchAlgorithms.DoubleMetaphoneLuceneQuery.name():matchAlgorithm,
					null);

				// GF9215
				boolean activeOnly = !searchInactive;
				nodes = restrictToActiveStatus(nodes, activeOnly);
			}

			SortOptionList sortCriteria = null;
			Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});
			matchIterator =
				nodes.resolve(sortCriteria,null,null);
		}catch(Exception e){
			e.printStackTrace();
		}
		return matchIterator;

	}


	public ResolvedConceptReferencesIterator searchNodesForProperties(List names, int count,boolean soundsLike,
		boolean searchInactive){
        return searchNodesForProperties(names, count, soundsLike, searchInactive, null, null, null);
	}


	public ResolvedConceptReferencesIterator searchNodesForProperties(List names, int count,boolean soundsLike,
		boolean searchInactive, String searchSource, String roleToSearchIn, String associationToSearchIn){
		ResolvedConceptReferencesIterator matchIterator = null;
		try{
			String scheme = codingScheme.getRegisteredName();
			CodedNodeSet nodes1 = null;
			CodedNodeSet nodes2 = lbSvc.getCodingSchemeConcepts(scheme, null);

			String name = null;
			Iterator namesIte = names.iterator();
			String[] propList = getPropertyForCodingSchemeSearch();
			if(propList.length > 0)
				nodes1 = lbSvc.getCodingSchemeConcepts(scheme, null);
			String matchAlgorithm = "RegExp";
			if(soundsLike)
				matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

			while(namesIte.hasNext()){
				name = (String)namesIte.next();
				name = name.toLowerCase();
				if(name.indexOf(" ") > 0){
					name = "\"" + name + "\"";
					matchAlgorithm = MatchAlgorithms.LuceneQuery.name();
				}
				else{

					if(!soundsLike){
						name = ".*" + name + ".*";
						matchAlgorithm = "RegExp";
					}
				}
				if(soundsLike)
					matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

				if(propList.length > 0){

					nodes1 = nodes1.restrictToMatchingProperties(
						Constructors.createLocalNameList(
						propList),
						null,
						name,
						matchAlgorithm,
						null);
				}
				nodes2 = nodes2.restrictToMatchingDesignations(
					name,
					SearchDesignationOption.NON_PREFERRED_ONLY,
					matchAlgorithm,
					null);
			}

			CodedNodeSet nodes = null;
			if(propList.length > 0)
				nodes = nodes1.union(nodes2);
			else
				nodes = nodes2;


			if (searchSource != null && searchSource.compareTo("") != 0)
			{
				nodes = restrictToSource(nodes, searchSource);
			}


            matchIterator = null;
            //SearchNodeResultBean searchBean = null;
            ResolvedConceptReferenceList lst = null;
            CodedNodeSet nodes5 = null;
            CodedNodeSet nodes6 = null;

			if (roleToSearchIn != null && roleToSearchIn.compareTo("") != 0)
			{
				CodingSchemeVersionOrTag versionOrTag = new CodingSchemeVersionOrTag();
				CodedNodeGraph cng = lbSvc.getNodeGraph(codingSchemeName, versionOrTag, "roles");

				NameAndValueList asso_list =
					createNameAndValueList(
					new String[] {roleToSearchIn}, null);

				cng = cng.restrictToAssociations(asso_list, null);

				cng = cng.restrictToTargetCodes(nodes);

				lst =
					cng.resolveAsList(null, true, false, // graphFocus, resolveForward, resolveBackward
					1, 1, null, null, null, 1000);

				nodes5 = lbSvc.getCodingSchemeConcepts(scheme, null);
				nodes5 = nodes5.restrictToCodes(resolvedConceptReferenceListToConceptReferenceList(lst));
			}

			if (associationToSearchIn != null && associationToSearchIn.compareTo("") != 0)
			{
				CodingSchemeVersionOrTag versionOrTag = new CodingSchemeVersionOrTag();
				CodedNodeGraph cng = lbSvc.getNodeGraph(codingSchemeName, versionOrTag, null);

				NameAndValueList asso_list =
					createNameAndValueList(
					new String[] {associationToSearchIn}, null);

				cng = cng.restrictToAssociations(asso_list, null);
				cng = cng.restrictToTargetCodes(nodes);

				lst =
					cng.resolveAsList(null, true, false, // graphFocus, resolveForward, resolveBackward
					1, 1, null, null, null, 1000);

				nodes6 = lbSvc.getCodingSchemeConcepts(scheme, null);
				nodes6 = nodes6.restrictToCodes(resolvedConceptReferenceListToConceptReferenceList(lst));
			}

			if (nodes5 != null && nodes6 != null)
			{
				nodes = nodes5.union(nodes6);
			}
			else if (nodes5 == null && nodes6 != null)
			{
				nodes = nodes6;
			}
			else if (nodes5 != null && nodes6 == null)
			{
				nodes = nodes5;
			}

			// GF9215
			boolean activeOnly = !searchInactive;
			nodes = restrictToActiveStatus(nodes, activeOnly);

			SortOptionList sortCriteria = null;
			Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});
			matchIterator =
				nodes.resolve(sortCriteria, null,null);//ConvenienceMethods.createLocalNameList(getPropertyForCodingScheme(cs)),null);

	 }catch(Exception e){
		 e.printStackTrace();
	 }
	 return matchIterator;
  }


  public ResolvedConceptReferencesIterator searchNodesForProperties(List names, int count, int algorithm, String[] properties,boolean soundsLike, boolean includeObsolete){
 		ResolvedConceptReferencesIterator matchIterator = null;
		try{
			String scheme = codingScheme.getRegisteredName();
			CodedNodeSet nodes1 = null;
			CodedNodeSet nodes2 = lbSvc.getCodingSchemeConcepts(scheme, null);

			String name = null;
			Iterator namesIte = names.iterator();
			String[] propList = properties;
			if(propList.length > 0)
					nodes1 = lbSvc.getCodingSchemeConcepts(scheme, null);
			String matchAlgorithm = "RegExp";
			if(soundsLike)
						matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

			while(namesIte.hasNext()){
				    name = (String)namesIte.next();
				    name = name.toLowerCase();
					if(!soundsLike){
						name = replacePeriod(name);
						switch(algorithm){
							case SEARCH_STARTS_WITH:name = name + ".*";
								break;
							case SEARCH_ENDS_WITH:name = ".*" + name;
								break;
							case SEARCH_CONTAINS:name = ".*" + name + ".*";
								break;
							case SEARCH_EXACT_MATCH:
								break;
						}
					}

					if(propList.length > 0){

						nodes1 = nodes1.restrictToMatchingProperties(
									Constructors.createLocalNameList(
										propList),
										null,
										name,
										matchAlgorithm,
										null);
					}

			}

			CodedNodeSet nodes = null;
			if(propList.length > 0)
				nodes = nodes1;//.union(nodes2);


			// GF9215
			boolean activeOnly = !includeObsolete;
			nodes = restrictToActiveStatus(nodes, activeOnly);


			SortOptionList sortCriteria = null;
			    Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});
			// Analyze the result ...
			matchIterator =
				nodes.resolve(sortCriteria, null,null);//ConvenienceMethods.createLocalNameList(getPropertyForCodingScheme(cs)),null);

	 }catch(Exception e){
	 	e.printStackTrace();
     }
     return matchIterator;
  }


  /*
  public ResolvedConceptReferencesIterator searchNodesForAssociations(List names, int count, boolean soundsLike, boolean includeObsolete, String roleToSearchIn)
  {
	  ResolvedConceptReferencesIterator matchIterator = null;
      try{
		  String scheme = codingScheme.getRegisteredName();
		  CodedNodeSet nodes3 = lbSvc.getCodingSchemeConcepts(scheme, null);
		  CodedNodeSet nodes4 = lbSvc.getCodingSchemeConcepts(scheme, null);
		  String name = "";
		  Iterator namesIte = names.iterator();
		  String name1 = "";
		  String temp="";
		  String temp1="";
		  String matchAlgorithm = "RegExp";
		  if(soundsLike)
			  matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();
		  int counter = 0;
		  while(namesIte.hasNext()){
			  name = (String)namesIte.next();
			  name1= name.toLowerCase();
			  name = name.toLowerCase();

			  name1 = replacePeriod(name1);

			  if(name.indexOf(" ") > 0){
				  name = "\"" + name + "\"";
				  matchAlgorithm = MatchAlgorithms.LuceneQuery.name();
			  }
			  else{
				  if(!soundsLike){
					  name = ".*" + name + ".*";
					  matchAlgorithm = "RegExp";
				  }
				  //name1 = name1 + "*";
			  }
			  if(soundsLike)
				  matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

			  nodes3 = nodes3.restrictToMatchingProperties(
				  Constructors.createLocalNameList(
				  "conceptCode"),null,
				  ".*" + name1 + ".*",
				  "RegExp",
				  null);

			  nodes4 = nodes4.restrictToMatchingDesignations(
				  name,
				  true,
				  matchAlgorithm,//soundsLike?MatchAlgorithms.DoubleMetaphoneLuceneQuery.name():"RegExp",
				  null);
		  }

		  CodedNodeSet nodes = nodes3.union(nodes4);

		  CodingSchemeVersionOrTag versionOrTag = new CodingSchemeVersionOrTag();
		  CodedNodeGraph cng = lbSvc.getNodeGraph(codingSchemeName, versionOrTag, null);

		  NameAndValueList asso_list =
			  createNameAndValueList(
			  new String[] {roleToSearchIn}, null);

		  cng = cng.restrictToAssociations(asso_list, null);
		  cng = cng.restrictToTargetCodes(nodes);

		  ResolvedConceptReferenceList lst =
			  cng.resolveAsList(null, true, false, // graphFocus, resolveForward, resolveBackward
			  1, 1, null, null, null, 1000);

		  CodedNodeSet nodes5 = lbSvc.getCodingSchemeConcepts(scheme, null);
		  if (lst == null) return null;
		  ResolvedConceptReference[] rcra = lst.getResolvedConceptReference();
		  if (rcra.length == 0) return null;

		  nodes5 = nodes5.restrictToCodes(resolvedConceptReferenceListToConceptReferenceList(lst));

		  // GF9215
		  boolean activeOnly = !includeObsolete;
		  nodes5 = restrictToActiveStatus(nodes5, activeOnly);

		  SortOptionList sortCriteria = null;
		  Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});
		  matchIterator =
			  nodes5.resolve(sortCriteria, null,null);//ConvenienceMethods.createLocalNameList(getPropertyForCodingScheme(cs)),null);

	  }catch(Exception e){
		  e.printStackTrace();
	  }
	  return matchIterator;
  }
  */
   public ResolvedConceptReferencesIterator searchNodesForAssociations(List names, int count, boolean soundsLike, boolean includeObsolete, String roleToSearchIn)
  {
	  ResolvedConceptReferencesIterator matchIterator = null;
      try{
		  String scheme = codingScheme.getRegisteredName();
		  CodedNodeSet nodes3 = lbSvc.getCodingSchemeConcepts(scheme, null);
		  CodedNodeSet nodes4 = lbSvc.getCodingSchemeConcepts(scheme, null);
		  String name = "";
		  Iterator namesIte = names.iterator();
		  String name1 = "";
		  String temp="";
		  String temp1="";
		  String matchAlgorithm = "RegExp";
		  if(soundsLike)
			  matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();
		  int counter = 0;
		  while(namesIte.hasNext()){
			  name = (String)namesIte.next();
			  name1= name.toLowerCase();
			  name = name.toLowerCase();

			  name1 = replacePeriod(name1);

			  if(name.indexOf(" ") > 0){
				  name = "\"" + name + "\"";
				  matchAlgorithm = MatchAlgorithms.LuceneQuery.name();
			  }
			  else{
				  if(!soundsLike){
					  name = ".*" + name + ".*";
					  matchAlgorithm = "RegExp";
				  }
				  //name1 = name1 + "*";
			  }
			  if(soundsLike)
				  matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

			  nodes3 = nodes3.restrictToMatchingProperties(
				  Constructors.createLocalNameList(
				  "conceptCode"),null,
				  ".*" + name1 + ".*",
				  "RegExp",
				  null);

			  nodes4 = nodes4.restrictToMatchingDesignations(
				  name,
				  true,
				  matchAlgorithm,//soundsLike?MatchAlgorithms.DoubleMetaphoneLuceneQuery.name():"RegExp",
				  null);
		  }

		  CodedNodeSet nodes = nodes3.union(nodes4);

		  SortOptionList sortCriteria = null;
		  Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});

		  ResolvedConceptReferenceList temp_list = nodes.resolveToList(sortCriteria, null, null, 1000);
		  if (temp_list.getResolvedConceptReferenceCount() == 0)
		  {
			   System.out.println("No matches.");
			   return null;
		  }
		  CodingSchemeVersionOrTag versionOrTag = new CodingSchemeVersionOrTag();
		  CodedNodeGraph cng = lbSvc.getNodeGraph(codingSchemeName, versionOrTag, null);

		  NameAndValueList asso_list =
			  createNameAndValueList(
			  new String[] {roleToSearchIn}, null);

		  cng = cng.restrictToAssociations(asso_list, null);
		  cng = cng.restrictToTargetCodes(nodes);

		  ResolvedConceptReferenceList lst =
			  cng.resolveAsList(null, true, false, // graphFocus, resolveForward, resolveBackward
			  1, 1, null, null, null, 1000);


		  if (lst == null) return null;
		  ResolvedConceptReference[] rcra = lst.getResolvedConceptReference();
		  if (rcra.length == 0) return null;

		  CodedNodeSet nodes5 = lbSvc.getCodingSchemeConcepts(scheme, null);

		  nodes5 = nodes5.restrictToCodes(resolvedConceptReferenceListToConceptReferenceList(lst));

		  // GF9215
		  boolean activeOnly = !includeObsolete;
		  nodes5 = restrictToActiveStatus(nodes5, activeOnly);

		  matchIterator =
			  nodes5.resolve(sortCriteria, null,null);//ConvenienceMethods.createLocalNameList(getPropertyForCodingScheme(cs)),null);

	  }catch(Exception e){
		  e.printStackTrace();
	  }
	  return matchIterator;
  }


  public ResolvedConceptReferencesIterator searchNodesForName(List names, int count, int algorithm, boolean soundsLike, boolean includeObsolete){
	ResolvedConceptReferencesIterator matchIterator = null;
	try{
		String scheme = codingScheme.getRegisteredName();
		CodedNodeSet nodes4 = lbSvc.getCodingSchemeConcepts(scheme, null);
		CodedNodeSet nodes2 = null;
		CodedNodeSet nodes1 = null;
		String name = "";
		Iterator namesIte = names.iterator();
		String name1 = "";
		String temp="";
		String temp1="";
		String matchAlgorithm = "RegExp";

		if(soundsLike)
					matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();

		int counter = 0;

		while(namesIte.hasNext()){
				name = (String)namesIte.next();
				name = name.toLowerCase();

				if(!soundsLike){
					name = replacePeriod(name);
					switch(algorithm){
						case SEARCH_STARTS_WITH:name = name + ".*";
							break;
						case SEARCH_ENDS_WITH:name = ".*" + name;
							break;
						case SEARCH_CONTAINS:name = ".*" + name + ".*";
							break;
						case SEARCH_EXACT_MATCH:
							break;
					}

					matchAlgorithm = "RegExp";
				}

				nodes4 = nodes4.restrictToMatchingDesignations(
				name,
				true,
				matchAlgorithm,
				null);

		}

		CodedNodeSet nodes = nodes4;

		// GF9215
		boolean activeOnly = !includeObsolete;
		nodes = restrictToActiveStatus(nodes, activeOnly);

		// Sort by search engine recommendation & code ...
		SortOptionList sortCriteria = null;
			Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});
		// Analyze the result ...
		matchIterator =
			nodes.resolve(sortCriteria,null,null);//ConvenienceMethods.createLocalNameList(getPropertyForCodingScheme(cs)),null);
	 }catch(Exception e){
	 	e.printStackTrace();
     }
     return matchIterator;

  }






  public ResolvedConceptReferencesIterator searchNodesForName(List names, int count,boolean soundsLike, boolean searchInactive,
	  String searchSource, String roleToSearchIn, String associationToSearchIn){
      ResolvedConceptReferencesIterator matchIterator = null;
      try{
		  java.lang.String formalName = codingScheme.getFormalName();
		  java.lang.String version =	codingScheme.getRepresentsVersion();

		  CodingSchemeVersionOrTag versionOrTag = new CodingSchemeVersionOrTag();
		  versionOrTag.setVersion(codingScheme.getRepresentsVersion());

		  String scheme = codingScheme.getRegisteredName();
		  CodedNodeSet nodes3 = lbSvc.getCodingSchemeConcepts(formalName, versionOrTag);

		  CodedNodeSet nodes4 = lbSvc.getCodingSchemeConcepts(formalName, versionOrTag);

		  CodedNodeSet nodes2 = null;
		  CodedNodeSet nodes1 = null;
		  String name = "";
		  Iterator namesIte = names.iterator();
		  String name1 = "";
		  String temp="";
		  String temp1="";
		  String matchAlgorithm = "contains";
		  if(soundsLike)
			  matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();
		  int counter = 0;

		  while(namesIte.hasNext()){
			  name = (String)namesIte.next();
			  name1= name.toLowerCase();
			  name = name.toLowerCase();

			  name1 = replacePeriod(name1);

			  if(name.indexOf(" ") > 0){
				  name = "\"" + name + "\"";
				  matchAlgorithm = MatchAlgorithms.LuceneQuery.name();
			  }
			  else{
				  if(!soundsLike){
					  //name = ".*" + name + ".*";
					  matchAlgorithm = "contains";
				  }
			  }
			  if(soundsLike)
			  {
				  matchAlgorithm = MatchAlgorithms.DoubleMetaphoneLuceneQuery.name();
			  }

			  nodes3 = nodes3.restrictToMatchingProperties(
				  Constructors.createLocalNameList(
				  "conceptCode"),null,
				  //".*" + name1 + ".*",
				  name1,
				  "contains",
				  null);

			  nodes4 = nodes4.restrictToMatchingDesignations(
				  name,
				  true,
				  matchAlgorithm,//soundsLike?MatchAlgorithms.DoubleMetaphoneLuceneQuery.name():"RegExp",
				  null);

			  if (searchSource != null && searchSource.compareTo("") != 0)
			  {
				  nodes3 = restrictToSource(nodes3, searchSource);
				  nodes4 = restrictToSource(nodes4, searchSource);
			  }

		  }
		  CodedNodeSet nodes = nodes3.union(nodes4);
		  if (searchSource != null && searchSource.compareTo("") != 0)
		  {
			  nodes = restrictToSource(nodes, searchSource);
		  }


		  matchIterator = null;
		  ResolvedConceptReferenceList lst = null;
		  CodedNodeSet nodes5 = null;
		  CodedNodeSet nodes6 = null;

		  if (roleToSearchIn != null && roleToSearchIn.compareTo("") != 0)
		  {
			  CodedNodeGraph cng = lbSvc.getNodeGraph(codingSchemeName, versionOrTag, "roles");
			  NameAndValueList asso_list =
				  createNameAndValueList(
				  new String[] {roleToSearchIn}, null);

			  cng = cng.restrictToAssociations(asso_list, null);
			  cng = cng.restrictToTargetCodes(nodes);
			  lst = cng.resolveAsList(null, true, false, // graphFocus, resolveForward, resolveBackward
				  1, 1, null, null, null, 1000);

			  nodes5 = lbSvc.getCodingSchemeConcepts(scheme, null);
			  try {
			  	 nodes5 = nodes5.restrictToCodes(resolvedConceptReferenceListToConceptReferenceList(lst));
			  } catch (Exception ex) {

			  }
		  }

		  if (associationToSearchIn != null && associationToSearchIn.compareTo("") != 0)
		  {
			  versionOrTag = new CodingSchemeVersionOrTag();
			  CodedNodeGraph cng = lbSvc.getNodeGraph(codingSchemeName, versionOrTag, null);

			  NameAndValueList asso_list =
				  createNameAndValueList(
				  new String[] {associationToSearchIn}, null);

			  cng = cng.restrictToAssociations(asso_list, null);
			  cng = cng.restrictToTargetCodes(nodes);
			  lst = cng.resolveAsList(null, true, false, // graphFocus, resolveForward, resolveBackward
				  1, 1, null, null, null, 1000);

			  nodes6 = lbSvc.getCodingSchemeConcepts(scheme, null);
			  nodes6 = nodes6.restrictToCodes(resolvedConceptReferenceListToConceptReferenceList(lst));
		  }

		  if (nodes5 != null && nodes6 != null)
		  {
			  nodes = nodes5.union(nodes6);
		  }
		  else if (nodes5 == null && nodes6 != null)
		  {
			  nodes = nodes6;
		  }
		  else if (nodes5 != null && nodes6 == null)
		  {
			  nodes = nodes5;
		  }

	      // GF9215
  		  boolean activeOnly = !searchInactive;
		  nodes = restrictToActiveStatus(nodes, activeOnly);

		  SortOptionList sortCriteria = null;
		  Constructors.createSortOptionList(new String[]{"matchToQuery", "code"});
		  // Analyze the result .

		  matchIterator =
			  nodes.resolve(sortCriteria, null,null);//ConvenienceMethods.createLocalNameList(getPropertyForCodingScheme(cs)),null);
	 }catch(Exception e){
		 e.printStackTrace();
     }
     return matchIterator;

  }

     public ResolvedConceptReferenceList getNext(ResolvedConceptReferencesIterator iterator)
     {
		 return iterator.getNext();
	 }

	 public void dump_matches(ResolvedConceptReferencesIterator iterator, int maxToReturn)
	 {
		 if (iterator == null)
		 {
			 System.out.println("NO match.");
			 return;
		 }
		 try {
			 int iteration = 0;
			 while (iterator.hasNext())
			 {
				 iteration++;
				 iterator = iterator.scroll(maxToReturn);
				 ResolvedConceptReferenceList rcrl = iterator.getNext();
				 ResolvedConceptReference[] rcra = rcrl.getResolvedConceptReference();
				 for (int i=0; i<rcra.length; i++)
				 {
					 ResolvedConceptReference rcr = rcra[i];
					 CodedEntry ce = rcr.getReferencedEntry();
					 System.out.println("Iteration " + iteration + " " + ce.getConceptCode() + " " + ce.getEntityDescription().getContent());
				 }
			 }
	     } catch (Exception e) {
			 e.printStackTrace();
		 }
	 }

///////////////////////////////////////////////////////////////////////////////////////////////////

	public Vector searchNodes(String scheme, String version, String tag, String searchTerm, int limit, String source,
						 boolean cui, boolean shortResult, boolean score)
	{
		 Vector v = new Vector();
		 /*
		 if (cui)
		 {
			CodedEntry concept  = getCodedEntry(scheme, version, tag, searchTerm);
			if (concept != null)
			{
				v.add(concept);
				return v;
			}
		 }
     	 else if (source != null && source.compareTo("*") != 0) // search by source
		 {
			 return findCodedEntriesWithSourceCodeMatching(scheme, version, tag, source, searchTerm, limit);
		 }
		 */

         CodingSchemeVersionOrTag csvt = new CodingSchemeVersionOrTag();
         csvt.setVersion(version);

         Vector w = new Vector();
         HashSet hset = new HashSet();
         try {
         	 //lbSvc = new LexBIGServiceImpl();
			 v = matchSynonyms(searchTerm, lbSvc, scheme, csvt, source);
			 for (int i=0; i<v.size(); i++)
			 {
				 CodedEntry ce = (CodedEntry) v.elementAt(i);
				 if (!hset.contains(ce.getConceptCode()))
				 {
					 w.add(ce);
					 hset.add(ce.getConceptCode());
				 }
			 }
			 v = matchSpell(searchTerm, lbSvc, scheme, csvt, source);
			 for (int i=0; i<v.size(); i++)
			 {
				 CodedEntry ce = (CodedEntry) v.elementAt(i);
				 if (!hset.contains(ce.getConceptCode()))
				 {
					 w.add(ce);
					 hset.add(ce.getConceptCode());
				 }
			 }

			 v = matchTermCompletion(searchTerm, lbSvc, scheme, csvt, source);
			 for (int i=0; i<v.size(); i++)
			 {
				 CodedEntry ce = (CodedEntry) v.elementAt(i);
				 if (!hset.contains(ce.getConceptCode()))
				 {
					 w.add(ce);
					 hset.add(ce.getConceptCode());
				 }
			 }

			 v = matchWordCompletion(searchTerm, lbSvc, scheme, csvt, source);
			 for (int i=0; i<v.size(); i++)
			 {
				 CodedEntry ce = (CodedEntry) v.elementAt(i);
				 if (!hset.contains(ce.getConceptCode()))
				 {
					 w.add(ce);
					 hset.add(ce.getConceptCode());
				 }
			 }

			 v = matchSubquery(searchTerm, lbSvc, scheme, csvt, source);
			 for (int i=0; i<v.size(); i++)
			 {
				 CodedEntry ce = (CodedEntry) v.elementAt(i);
				 if (!hset.contains(ce.getConceptCode()))
				 {
					 w.add(ce);
					 hset.add(ce.getConceptCode());
				 }
			 }
		 } catch (Exception e) {
			 e.printStackTrace();
		 }
		 return w;
	}


	/**
	 * Display concepts and related text strings matching the given string.
	 *
	 * @throws LBException
	 * @param s The test string.
	 * @param lbSvc
	 * @param scheme
	 * @param csvt
	 * @param source
	 */
	protected Vector matchSynonyms(String s, LexBIGService lbSvc, String scheme, CodingSchemeVersionOrTag csvt, String source)
		throws LBException
	{
        Vector v = new Vector();
		// Add restriction to narrow the scope.
		// Q: How does Metaphrase determine raw term for search (words
		//    are pre-normalized? is match dependent on order of words
		//    provided in phrase)?
		// Q: Best algorithm to use (exact match, contains, logical stemmed)?
		// Q: What punctuation is to be ignored on search?
		// Q: Do we always need to return a synonym match?   If not where
		//    boundary defined to know what is 'close enough' to match?
		//    Do all non-stop words in the search string need to be
		//    in the matched concept?  Can the concept text be a superset?
		//
		// An attempt is made to use a partial normalized form on search by
		// removing stop words and utilizing a stemmed query algorithm.
		// Query is performed over text representations that contain all
		// non-stop words for the given string.
		//
		// On resolve, we sort by lucene score ('matchToQuery' sort algorithm).

		StringBuffer searchPhrase = new StringBuffer();
		String[] words = toWords(s, true);
		for (int i = 0; i < words.length; i++) {
			if (i > 0)
				searchPhrase.append(" AND ");
			searchPhrase.append(words[i]);
		}

		// Define the code set and add restrictions ...
		CodedNodeSet nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		if (source != null && source.compareTo("*") != 0)
		{
			nodes = restrictToSource(nodes, source);
		}
		nodes = nodes.restrictToMatchingDesignations(
			searchPhrase.toString(), SearchDesignationOption.ALL, "StemmedLuceneQuery", null);
		SortOptionList sortCriteria =
			Constructors.createSortOptionList(new String[]{"matchToQuery"});
		PropertyType[] fetchTypes =
			new PropertyType[] {PropertyType.PRESENTATION};

		// Resolve and analyze the result ...
		ResolvedConceptReferenceList matches =
			nodes.resolveToList(sortCriteria, null, fetchTypes, -1);

		// Found a match?  If so, sort according to relevance.
		if (matches.getResolvedConceptReferenceCount() > 0) {
			// NOTE that a match so far only indicates that all of the words in the
			// passed in string also exist in a term assigned to the resolved
			// concepts.  It does not, however, exclude results where the terms
			// also have additional words.  This code currently processes only
			// full matches by calling getReferenceWeight and taking only those
			// values with weight '1'.

			// List concept references with exact correlation of at least one
			// concept term to the compare string.

			//final List<String> matchWords = Arrays.asList(words);

			final List matchWords = Arrays.asList(words);


			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				if (getReferenceWeight(ref, matchWords) == 1)
				{
				    CodedEntry ce = ref.getReferencedEntry();
				    v.add(ce);
				}
			}
		}
		return v;
	}

	/**
	 * Attempt to approximate spelling suggestions.
	 *
	 * @throws LBException
	 * @param s The test string.
	 * @param lbSvc
	 * @param scheme
	 * @param csvt
	 * @param source
	 */
	protected Vector matchSpell(String s, LexBIGService lbSvc, String scheme, CodingSchemeVersionOrTag csvt, String source)
		throws LBException
	{
        Vector v = new Vector();
		// Spell suggestion is based off entire phrase in comparison
		// to content stored in the ontology; no external dictionary
		// is utilized.  Two different algorithms are highlighted
		// for consideration. The first utilizes the lucene-based
		// Levenshtein distance algorithm.  The second utilizes the
		// DoubleMetaphoneLuceneQuery (sounds-like) algorithm.
		//
		// Q: Do we want to search all terms or just primary text?
		// Queries are currently made against all text representations,
		// but this could be narrowed.
		//
		// On resolve, we sort by lucene score ('matchToQuery' sort algorithm).

		// Levenshtein distance processing ...
		String[] words = toWords(s, true);
		String prefix = words[0].substring(0, 1);

		CodedNodeSet nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		if (source != null && source.compareTo("*") != 0)
		{
			nodes = restrictToSource(nodes, source);
		}
		StringBuffer searchPhrase = new StringBuffer(s).append('~');
		nodes = nodes.restrictToMatchingDesignations(
			searchPhrase.toString(), SearchDesignationOption.ALL,
			MatchAlgorithms.LuceneQuery.toString(), null);
		nodes = nodes.restrictToMatchingProperties(null, new PropertyType[] {PropertyType.PRESENTATION},
			prefix, "startsWith", null);
		SortOptionList sortCriteria =
			Constructors.createSortOptionList(new String[]{"matchToQuery"});

		// Resolve and analyze the result ...
		ResolvedConceptReferenceList matches =
			nodes.resolveToList(sortCriteria, null, new PropertyType[] {}, 5);

		// Found a match?
		if (matches.getResolvedConceptReferenceCount() > 0) {
			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				// OK, so we have it narrowed to a concept at this point but not a
				// specific term.  Narrow the choices to those that include the same
				// starting letter and number of words as our test phrase.
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				CodedEntry ce = ref.getReferencedEntry();
				v.add(ce);
			}
		}

		// Sounds-like processing ...
		nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		nodes = nodes.restrictToMatchingDesignations(
			s, SearchDesignationOption.ALL,
			MatchAlgorithms.DoubleMetaphoneLuceneQuery.toString(), null);
		nodes = nodes.restrictToMatchingProperties(null, new PropertyType[] {PropertyType.PRESENTATION},
			prefix, "startsWith", null);

		// Resolve and analyze the result ...
		matches = nodes.resolveToList(sortCriteria, null, new PropertyType[] {}, 5);

		// Found a match?
		if (matches.getResolvedConceptReferenceCount() > 0) {
			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				// Once again we have it narrowed to a concept at this point but not
				// a specific term.  Narrow the choices to those that include the same
				// starting letter and number of words as our test phrase.
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				CodedEntry ce = ref.getReferencedEntry();
				v.add(ce);
			}
		}
        return v;
	}

	/**
	 * Attempt to approximate term completion.
	 * @param s The test string.
	 * @param lbSvc
	 * @param scheme
	 * @param csvt
	 * @throws LBException
	 */
	@SuppressWarnings("unchecked")
	protected Vector matchTermCompletion(String s, LexBIGService lbSvc, String scheme, CodingSchemeVersionOrTag csvt, String source)
		throws LBException
	{
		//Util.displayMessage("\n*** Term completion ...");

		// Term completion is basically 'startsWith'.  Two different
		// queries are tried to match.  The first utilizes the standard
		// startsWith match algorithm.  The second utilizes regular
		// expressions to try and accomplish short-circuiting more
		// efficiently.
		//
		// Queries are currently made against all text representations,
		// but this could be narrowed.
		//
		// On resolve, we sort by lucene score ('matchToQuery' sort algorithm).

        Vector v = new Vector();

		String prefix = s.toLowerCase();
		String[] words = toWords(s, false);
		CodedNodeSet nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		if (source != null && source.compareTo("*") != 0)
		{
			nodes = restrictToSource(nodes, source);
		}
		nodes = nodes.restrictToMatchingDesignations(
			prefix, SearchDesignationOption.ALL,
			"startsWith", null);
		SortOptionList sortCriteria =
			Constructors.createSortOptionList(new String[]{"matchToQuery"});

		// Resolve and analyze the result ...
		ResolvedConceptReferenceList matches =
			nodes.resolveToList(sortCriteria, null, new PropertyType[] {}, 5);

		// Found a match?
		//Util.displayMessage("\tstartsWith (limited to 5 hits); short circuit after query...");
		if (matches.getResolvedConceptReferenceCount() > 0) {
			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				//printText(ref, false, prefix, words.length + 1);
			}
		} else {
			//Util.displayMessage("\tNo match found.");
		}

		// Try again with regular expression.
		nodes = nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		String regex = '^' + prefix + "\\W*\\w*\\Z";
		nodes.restrictToMatchingDesignations(
				regex, SearchDesignationOption.ALL,
				"RegExp", null);

		// Resolve and analyze the result ...
		matches = nodes.resolveToList(sortCriteria, null, new PropertyType[] {}, 5);

		// Found a match?
		//Util.displayMessage("\n\tRegExp match (limited to 5 hits); short circuit on query...");
		if (matches.getResolvedConceptReferenceCount() > 0) {
			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				//printText(ref, false, prefix, words.length + 1);
				CodedEntry ce = ref.getReferencedEntry();
				v.add(ce);

			}
		} else {
			//Util.displayMessage("\tNo match found.");
		}

		return v;
	}



	/**
	 * Attempt to approximate word completion.
	 *
	 * @throws LBException
	 * @param s The test string.
	 * @param lbSvc
	 * @param scheme
	 * @param csvt
	 * @param source
	 */
	//@SuppressWarnings("unchecked")
	protected Vector matchWordCompletion(String s, LexBIGService lbSvc, String scheme, CodingSchemeVersionOrTag csvt, String source)
		throws LBException
	{
        Vector v = new Vector();
		// For word completion, we just use a regular expression and
		// substitute any non-whitespace character for the substitution
		// character ('.').
		//
		// Q: Do we want to search all terms or just primary text?
		// Queries are currently made against all text representations,
		// but this could be narrowed.
		//
		// On resolve, we sort by lucene score ('matchToQuery' sort algorithm).

		String[] words = toWords(s, false);
		String prefix = s;
		CodedNodeSet nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		if (source != null && source.compareTo("*") != 0)
		{
			nodes = restrictToSource(nodes, source);
		}
		String regex = '^' + s.replaceAll("\\.", "\\\\S*") + "\\Z";
		nodes = nodes.restrictToMatchingDesignations(
				regex, SearchDesignationOption.ALL,
				"RegExp", null);
		SortOptionList sortCriteria =
			Constructors.createSortOptionList(new String[]{"matchToQuery"});

		// Resolve and analyze the result ...
		ResolvedConceptReferenceList matches =
			nodes.resolveToList(sortCriteria, null, new PropertyType[] {}, 5);

		if (matches.getResolvedConceptReferenceCount() > 0) {
			int dotIndex = prefix.indexOf('.');
			if (dotIndex < 0)
				dotIndex = prefix.length();
			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				CodedEntry ce = ref.getReferencedEntry();
				v.add(ce);
			}
		}
		return v;

	}

	/**
	 * Attempt to approximate compositional or sub-query match.
	 *
	 * @throws LBException
	 * @param s The test string.
	 * @param lbSvc
	 * @param scheme
	 * @param csvt
	 * @param source
	 */
	protected Vector matchSubquery(String s, LexBIGService lbSvc, String scheme, CodingSchemeVersionOrTag csvt, String source)
		throws LBException
	{
		Vector v = new Vector();

		// This is basically just the default lucene match; no special syntax
		// required.
		//
		// Q: Do we want to search all terms or just primary text?
		// Queries are currently made against preferred text representations,
		// but this could be widened.
		//
		// On resolve, we sort by lucene score ('matchToQuery' sort algorithm).

		CodedNodeSet nodes = lbSvc.getCodingSchemeConcepts(scheme, csvt);
		if (source != null && source.compareTo("*") != 0)
		{
			nodes = restrictToSource(nodes, source);
		}
		nodes = nodes.restrictToMatchingDesignations(
				s, SearchDesignationOption.PREFERRED_ONLY,
				"LuceneQuery", null);

		// Resolve and analyze the result ...
		ResolvedConceptReferenceList matches = nodes.resolveToList(null, null, new PropertyType[] {}, -1);

		// Found a match?
		if (matches.getResolvedConceptReferenceCount() > 0) {
			for (int i = 0; i < matches.getResolvedConceptReferenceCount(); i++) {
				ResolvedConceptReference ref = matches.getResolvedConceptReference(i);
				CodedEntry ce = ref.getReferencedEntry();
				v.add(ce);
			}
		}
		return v;
	}

	/**
	 * Return a relative weight between 0 and 1 that indicates how well the
	 * given reference maps to a set of words.
	 *
	 * @param ref
	 * @param matchWords
	 */
	//protected float getReferenceWeight(ResolvedConceptReference ref, List<String> matchWords) {
	protected float getReferenceWeight(ResolvedConceptReference ref, List matchWords) {
		float weight = 0;
		CodedEntry ce = ref.getReferencedEntry();
		int presCount = ce.getPresentationCount();
		for (int i = 0; i < presCount; i++) {
			weight = Math.max(weight, getTextWeight(ce.getPresentation(i).getText().getContent(), matchWords));
		}
		return weight;
	}

	/**
	 * Return a relative weight between 0 and 1 that indicates how well the
	 * given string maps to a set of words.
	 *
	 * @param text
	 * @param matchWords
	 */
	protected float getTextWeight(String text, List<String> matchWords) {
		int matchedInTextWords = 0;
		int matchedInCompareWords = 0;
		String[] textWords = toWords(text, true);
		Set<String> textWordSet = new HashSet<String>();
		for (int i = 0; i < textWords.length; i++) {
			String word = textWords[i];
			textWordSet.add(word);
			if (matchWords.contains(word))
				matchedInCompareWords++;
		}
		for (Iterator<String> compareWords = matchWords.iterator(); compareWords.hasNext(); ) {
			String word = compareWords.next();
			if (textWordSet.contains(word))
				matchedInTextWords++;
		}
		float textToCompareRatio = matchedInCompareWords/textWordSet.size();
		float compareToTextRatio = matchedInTextWords/matchWords.size();
		return (textToCompareRatio + compareToTextRatio)/2;
	}



    public static ConceptReferenceList createConceptReferenceList(String[] codes, String codeSystem)
    {
        if (codes == null)
        {
            return null;
        }
        ConceptReferenceList list = new ConceptReferenceList();
        for (int i = 0; i < codes.length; i++)
        {
            ConceptReference cr = new ConceptReference();
            cr.setCodingScheme(codeSystem);
            cr.setConceptCode(codes[i]);
            list.addConceptReference(cr);
        }
        return list;
    }



	/**
	 * Returns an array containing the individual white-space delimited words
	 * contained by the given string, removing stop words and normalizing to
	 * lower case.
	 *
	 * @param s
	 */

	protected String[] toWords(String s, boolean removeStopWords) {
		String[] words = s.split("\\s");
		List<String> adjusted = new ArrayList<String>();
		for (int i = 0; i < words.length; i++) {
			if (!removeStopWords || !STOP_WORDS.contains(words[i]))
				adjusted.add(words[i].toLowerCase());
		}
		return adjusted.toArray(new String[adjusted.size()]);
	}




     public void run()
     {
		 String[] propList = getPropertyForCodingSchemeSearch();
		 for (int i=0; i<propList.length; i++)
		 {
			 System.out.println(propList[i]);
		 }

		 String s = "....This is a test.";


		 System.out.println("\n\nString: " + s);

		 s = replacePeriod(s);

		 System.out.println("Replacement: " + s);

		 ArrayList names = new ArrayList();
		 names.add("Anatomy");
		 //names.add("Target");
		 int count = 100;
		 boolean soundsLike = true;
		 boolean searchInactive = true;

		 int maxToReturn = 100;
		 ResolvedConceptReferencesIterator rcri = null;

         // Definition:
         System.out.println("\n\n========================================== Match by Definition: " );

         try {
			 rcri = searchNodesForDefinition(names, count, soundsLike, searchInactive);
			 dump_matches(rcri, 5);
	     } catch (Exception e) {
			 e.printStackTrace();
		 }


         // Properties:
         System.out.println("\n\n========================================== Match by Properties: " );

		 names = new ArrayList();
		 names.add("Anatomy");
		 count = 100;
		 soundsLike = true;
		 searchInactive = true;

		 maxToReturn = 100;
		 String searchSource = null;
		 String roleToSearchIn = null;
		 String associationToSearchIn = null;


         try {
			 rcri = searchNodesForProperties(names, count, soundsLike, searchInactive, searchSource, roleToSearchIn, associationToSearchIn);
			 rcri = rcri.scroll(maxToReturn);
			 ResolvedConceptReferenceList rcrl = rcri.getNext();
			 ResolvedConceptReference[] rcra = rcrl.getResolvedConceptReference();
			 for (int i=0; i<rcra.length; i++)
			 {
				 ResolvedConceptReference rcr = rcra[i];

				 CodedEntry ce = rcr.getReferencedEntry();
				 System.out.println(ce.getConceptCode() + " " + ce.getEntityDescription().getContent());

			 }
	     } catch (Exception e) {
			 e.printStackTrace();
		 }

		 names = new ArrayList();
		 names.add("fdsafdafd");
		 count = 100;
		 soundsLike = true;
		 searchInactive = true;

		 maxToReturn = 100;

		 // Roles:
		 System.out.println("\n\n========================================== Match by Roles: " );
         associationToSearchIn = "Technique_Has_Sample_Or_Specimen_Anatomy";

         try {
			 rcri = searchNodesForAssociations(names, count, soundsLike, searchInactive, associationToSearchIn);
			 if (rcri == null)
			 {
				 System.out.println("No match.");
			 }
			 else
			 {
				 rcri = rcri.scroll(maxToReturn);
				 ResolvedConceptReferenceList rcrl = rcri.getNext();
				 ResolvedConceptReference[] rcra = rcrl.getResolvedConceptReference();
				 for (int i=0; i<rcra.length; i++)
				 {
					 ResolvedConceptReference rcr = rcra[i];

					 CodedEntry ce = rcr.getReferencedEntry();
					 System.out.println(ce.getConceptCode() + " " + ce.getEntityDescription().getContent());

				 }
		     }
	     } catch (Exception e) {
			 e.printStackTrace();
		 }

		 names = new ArrayList();
		 names.add("Resources");
		 count = 100;
		 soundsLike = true;
		 searchInactive = true;

		 maxToReturn = 100;
         associationToSearchIn = "Concept_In_Subset";

		 // Associations:
		 System.out.println("\n\n========================================== Match by Associations: " );

         try {
			 rcri = searchNodesForAssociations(names, count, soundsLike, searchInactive, associationToSearchIn);

			 rcri = rcri.scroll(maxToReturn);
			 ResolvedConceptReferenceList rcrl = rcri.getNext();

			 ResolvedConceptReference[] rcra = rcrl.getResolvedConceptReference();
			 for (int i=0; i<rcra.length; i++)
			 {
				 ResolvedConceptReference rcr = rcra[i];

				 CodedEntry ce = rcr.getReferencedEntry();
				 System.out.println(ce.getConceptCode() + " " + ce.getEntityDescription().getContent());

			 }
	     } catch (Exception e) {
			 e.printStackTrace();
		 }

		 // MetaMatch:
		 System.out.println("\n\n========================================== MetaMatch: " );

         String searchTerm = "Target";
         int limit = 100;
         String source = null;
         boolean cui = false;
         boolean shortResult = false;
         boolean score = false;

	//public Vector searchNodes(String scheme, String version, String tag, String searchTerm, int limit, String source,
	//					 boolean cui, boolean shortResult, boolean score)

	     Vector v = searchNodes(codingSchemeName, version, null, searchTerm, limit, source,
						  cui, shortResult, score);
		 for (int i=0; i<v.size(); i++)
		 {
			 CodedEntry ce = (CodedEntry) v.elementAt(i);
			 System.out.println(ce.getConceptCode() + " " + ce.getEntityDescription().getContent());

		 }

	 }


	 //GF9215
	 private CodedNodeSet restrictToActiveStatus(CodedNodeSet cns, boolean activeOnly)
     {
		 if (cns == null) return null;
		 if (!activeOnly) return cns; // no restriction, do nothing
		 try {
		 	 cns = cns.restrictToStatus(CodedNodeSet.ActiveOption.ACTIVE_ONLY, null);
		 	 return cns;
		 } catch (Exception e) {
			 e.printStackTrace();
			 return null;
		 }
	 }

	 public static void main(String[] args)
	 {
		 String name = "NCI_Thesaurus";
		 String version = "06.12d";
		 String url = null;

		 SearchUtil test = new SearchUtil(name, version, url);
		 test.run();

	 }
}

